'Basisklasse fr ein Listenelement-Objekt
'Sie erbt von Component, das DesignTimeVisible(False)-Attribut sorgt dafr, 
'dass diese Komponente nicht im Komponentenfenster des Windows Forms Designer erscheint.  
<Serializable(), System.ComponentModel.DesignTimeVisible(False)> _
Public MustInherit Class ElementBase
    Inherits System.ComponentModel.Component

    Private m_ElementTyp As ElementTypen
    Private m_Collection As ElementCollection

#Region " Constructor "

    Public Sub New()

    End Sub

    Public Sub New(ByVal ElementTyp As ElementTypen)
        m_ElementTyp = ElementTyp
    End Sub

#End Region

#Region " Properties "
    'Diese Eigenschaft liefert eine Referenz der Collection, der das aktuelle Objekt angehrt
    'Dies ermglicht, die Collection selbst ber Events z.B. bei nderung von Propertys der von ElementBase erbenden
    'Objekte zu informieren.
    Public WriteOnly Property Collection() As ElementCollection
        Set(ByVal Value As ElementCollection)
            m_Collection = Value
        End Set
    End Property
    Friend Sub PropertyChanged()
        If m_Collection IsNot Nothing Then
            m_Collection.RaisePropertyChangedEvent()
        End If
    End Sub
    'Die Eigenschaft ElementTyp ist Browsable(False) weil der ElementTyp nur im Constructor festgelegt werden soll
    '(und nicht im PropertyGrid erscheinen soll)
    <System.ComponentModel.Browsable(False)> Public Property ElementTyp() As ElementTypen
        Get
            Return m_ElementTyp
        End Get
        Set(ByVal value As ElementTypen)
            m_ElementTyp = value
        End Set
    End Property

#End Region

    Public MustOverride Sub Paint(ByVal g As Graphics, ByVal Mitte As Integer, ByVal Top As Integer, ByVal ft As Font)
End Class
