Imports System.ComponentModel
Imports System.Drawing.Drawing2D
<DefaultProperty("Elemente")> _
Public Class TestControl
    Inherits System.Windows.Forms.Control

    Private m_BMP As Bitmap
    Private WithEvents m_Elemente As New ElementCollection

#Region " Designer Generated "
    Public Sub New()
        InitializeComponent()
        Me.SetStyle(ControlStyles.DoubleBuffer Or ControlStyles.UserPaint _
        Or ControlStyles.AllPaintingInWmPaint, True)
    End Sub
    'Das Steuerelement berschreibt den Lschvorgang zum Bereinigen der Komponentenliste.
    <System.Diagnostics.DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing AndAlso components IsNot Nothing Then
            components.Dispose()
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Wird vom Steuerelement-Designer bentigt.
    Private components As System.ComponentModel.IContainer

    ' Hinweis: Die folgende Prozedur ist fr den Komponenten-Designer erforderlich.
    ' Sie kann mit dem Komponenten-Designer gendert werden. Das Bearbeiten mit
    ' dem Code-Editor ist nicht mglich.
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub
#End Region

#Region " Properties "
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Content), Editor(GetType(ElementCollectionEditor), GetType(Drawing.Design.UITypeEditor))> _
    Public ReadOnly Property Elemente() As ElementCollection
        Get
            Return m_Elemente
        End Get
    End Property
#End Region

#Region " Painting "
    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(pe)

        'Benutzerdefinierten Zeichnungscode hier einfgen

        Dim g As Graphics = pe.Graphics

        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height, Drawing.Imaging.PixelFormat.Format32bppArgb)
            Dim gr As Graphics = Graphics.FromImage(m_BMP)
            gr.Clear(Me.BackColor)
            ' grauen Rahmen zeichnen
            Dim Pen1 As New Pen(SystemColors.ControlDark)
            gr.DrawRectangle(Pen1, New Rectangle(0, 0, Me.Width - 1, Me.Height - 1))
            Pen1.Dispose()

            ' blau-weien Gradienten zeichnen
            Dim Brsh As New LinearGradientBrush(New Point(0, 0), New Point(Me.Width, 16), Color.Blue, Color.White)
            gr.FillRectangle(Brsh, New Rectangle(1, 1, Me.Width - 2, 16))
            Brsh.Dispose()

            ' weien Text am oberen Rand zeichnen
            Dim Brsh1 As New SolidBrush(Color.White)
            gr.DrawString(Me.Name, Me.Font, Brsh1, 2, 2)
            Brsh1.Dispose()

            Dim TopPos As Integer = 18
            Dim Mitte As Integer = CSng(Me.Width) / 2
            Dim ZeilenAbstand As Integer = 16
            For Each El As ElementBase In m_Elemente
                El.Paint(gr, Mitte, TopPos, Me.Font)
                TopPos += ZeilenAbstand
            Next

        End If
        g.DrawImage(m_BMP, 0, 0)
    End Sub

    Private Sub m_Elemente_PropertyChanged() Handles m_Elemente.PropertyChanged
        m_BMP = Nothing
        Invalidate()
    End Sub

    Private Sub TestControl_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        m_BMP = Nothing
        Invalidate()
    End Sub
#End Region

End Class
